Loading...
Searching...
No Matches
dvbt_viterbi_decoder.h
Go to the documentation of this file.
/* -*- c++ -*- */
/*
* Copyright 2015 Free Software Foundation, Inc.
*
* SPDX-License-Identifier: GPL-3.0-or-later
*
*/
#ifndef INCLUDED_DTV_DVBT_VITERBI_DECODER_H
#define INCLUDED_DTV_DVBT_VITERBI_DECODER_H
#include <gnuradio/block.h>
#include <gnuradio/dtv/api.h>
#include <gnuradio/dtv/dvb_config.h>
#include <gnuradio/dtv/dvbt_config.h>
namespace gr {
namespace dtv {
/*!
* \brief DVB-T Viterbi decoder.
* \ingroup dtv
*
* ETSI EN 300 744 Clause 4.3.3 \n
* Mother convolutional code with rate 1/2. \n
* k=1, n=2, K=6. \n
* Generator polynomial G1=171(OCT), G2=133(OCT). \n
* Punctured to obtain rates of 2/3, 3/4, 5/6, 7/8. \n
* Data Input format: \n
* 000000X0X1 - QPSK. \n
* 0000X0X1X2X3 - 16QAM. \n
* 00X0X1X2X3X4X5 - 64QAM. \n
* Data Output format: Packed bytes (each bit is data). \n
* MSB - first, LSB last.
*/
class DTV_API dvbt_viterbi_decoder : virtual public block
{
public:
typedef std::shared_ptr<dvbt_viterbi_decoder> sptr;
/*!
* \brief Create a DVB-T Viterbi decoder.
*
* \param constellation constellation used. \n
* \param hierarchy hierarchy used. \n
* \param coderate coderate used. \n
* \param bsize block size.
*/
static sptr make(dvb_constellation_t constellation,
dvbt_hierarchy_t hierarchy,
dvb_code_rate_t coderate,
int bsize);
};
} // namespace dtv
} // namespace gr
#endif /* INCLUDED_DTV_DVBT_VITERBI_DECODER_H */
gr::block
The abstract base class for all 'terminal' processing blocks.
Definition gnuradio-runtime/include/gnuradio/block.h:63
gr::dtv::dvbt_viterbi_decoder
DVB-T Viterbi decoder.
Definition dvbt_viterbi_decoder.h:37
gr::dtv::dvbt_viterbi_decoder::make
static sptr make(dvb_constellation_t constellation, dvbt_hierarchy_t hierarchy, dvb_code_rate_t coderate, int bsize)
Create a DVB-T Viterbi decoder.
gr::dtv::dvbt_viterbi_decoder::sptr
std::shared_ptr< dvbt_viterbi_decoder > sptr
Definition dvbt_viterbi_decoder.h:39
dvb_config.h
dvbt_config.h
block.h
api.h
DTV_API
#define DTV_API
Definition gr-dtv/include/gnuradio/dtv/api.h:18
gr::dtv::dvb_code_rate_t
dvb_code_rate_t
Definition dvb_config.h:19
gr::dtv::dvbt_hierarchy_t
dvbt_hierarchy_t
Definition dvbt_config.h:14
gr::dtv::dvb_constellation_t
dvb_constellation_t
Definition dvb_config.h:79
gr
GNU Radio logging wrapper.
Definition basic_block.h:29